/* This file has been automatically generated by builder part of the ferite distribution */
/* file: array_Array.c */
/* namespace: Array */

#include <ferite.h>       /* we need this without a doubt */
#include "array_header.h"  /* this is the module header */

FE_NS_FUNCTION( array_Array_size )
{
   FeriteUnifiedArray *a;

   ferite_get_parameters( params, 1, &a );

   { /* Main function body. */
 
        FE_RETURN_LONG( a->size );
    
   }
   FE_RETURN_VOID;
}

FE_NS_FUNCTION( array_Array_push )
{
   FeriteUnifiedArray *a;
   FeriteVariable *var = params[1];

   ferite_get_parameters( params, 2, &a, NULL );

   { /* Main function body. */
 
        __ferite_uarray_push( script, a, var );
    
   }
   FE_RETURN_VOID;
}

FE_NS_FUNCTION( array_Array_walk )
{
   FeriteUnifiedArray *a;
   char *functionName = fcalloc( strlen(VAS(params[1]))+1, sizeof(char) );

   ferite_get_parameters( params, 2, &a, functionName );

   { /* Main function body. */
 
        FeriteHashBucket *buk;

        if( a->iter == NULL){
            a->iter = __ferite_create_iterator( script );
        }

        buk = __ferite_uarray_walk_linear( script, a, a->iter );

        if( buk == NULL ){
            ffree( a->iter );
            a->iter = NULL;
            FE_RETURN_LONG(0);
        }

/*        if(var != NULL){
            ffree(var);
        }

        memcpy(var,buk->data,sizeof(FeriteVariable));*/
        FE_RETURN_LONG(1);
    
   }
   FE_RETURN_VOID;
}

FE_NS_FUNCTION( array_Array_del )
{
   FeriteUnifiedArray *a;
   FeriteVariable *var = params[1];

   ferite_get_parameters( params, 2, &a, NULL );

   { /* Main function body. */
 
        __ferite_uarray_del_var( script, a, var );
    
   }
   FE_RETURN_VOID;
}

FE_NS_FUNCTION( array_Array_pop )
{
   FeriteUnifiedArray *a;

   ferite_get_parameters( params, 1, &a );

   { /* Main function body. */
 
        FeriteVariable *var;

        var = __ferite_uarray_pop( script, a );
        FE_RETURN_VAR( var );
    
   }
   FE_RETURN_VOID;
}

FE_NS_FUNCTION( array_Array_keys )
{
   FeriteUnifiedArray *a;

   ferite_get_parameters( params, 1, &a );

   { /* Main function body. */
 
        FeriteVariable *out, *tmp;
        FeriteIterator *iter;
        FeriteHashBucket *var;
        int i = 0;
        char *key;

        out = __ferite_create_uarray_variable("ret-array_keys",50);
        iter = __ferite_create_iterator( script );
        key = fmalloc( 1024 ); bzero(key,1024);

        while( var = __ferite_uarray_walk( script, a,iter ) )
        {
            sprintf( key,"ret-%d",i );
            tmp = fe_new_str( key,var->id );
            __ferite_uarray_add( script, VAUA(out),tmp,key,i );
            i++;
        }
        ffree(key);
        ffree(iter);
        FE_RETURN_VAR(out);
    
   }
   FE_RETURN_VOID;
}

FE_NS_FUNCTION( array_Array_print )
{
   FeriteUnifiedArray *vars;

   ferite_get_parameters( params, 1, &vars );

   { /* Main function body. */
 
       FeriteIterator *iter;
       FeriteHashBucket *buk;
       iter = __ferite_create_iterator(script);
       
       while((buk = (FeriteHashBucket*)__ferite_hash_walk(script,vars->hash,iter)) != NULL) {
         printf("['%s'] = ",buk->id);
         if(((FeriteVariable *)(buk->data))->type == F_VAR_STR) {
            printf("'%s'\n",VAS(((FeriteVariable*)(buk->data))));
         } else {
            printf("<Ferite %s>\n",
                  __ferite_variable_id_to_str(script,
                     ((FeriteVariable*)(buk->data))->type));
         }
       }
       ffree(iter);
    
   }
   FE_RETURN_VOID;
}

FE_NS_FUNCTION( array_Array_shift )
{
   FeriteUnifiedArray *a;

   ferite_get_parameters( params, 1, &a );

   { /* Main function body. */
 
        FeriteVariable *var;

        var = __ferite_uarray_shift( script, a );
        FE_RETURN_VAR( var );
    
   }
   FE_RETURN_VOID;
}

FE_NS_FUNCTION( array_Array_unshift )
{
   FeriteUnifiedArray *a;
   FeriteVariable *var = params[1];

   ferite_get_parameters( params, 2, &a, NULL );

   { /* Main function body. */
 
        __ferite_uarray_unshift( script, a, var );
    
   }
   FE_RETURN_VOID;
}

FE_NS_FUNCTION( array_Array_getIndex )
{
   FeriteUnifiedArray *a;
   char *var = fcalloc( strlen(VAS(params[1]))+1, sizeof(char) );

   ferite_get_parameters( params, 2, &a, var );

   { /* Main function body. */
 
        int index;

        index = __ferite_uarray_find_index( script, a, var );
	    ffree(var);
        FE_RETURN_LONG(index);
    
   }
   FE_RETURN_VOID;
}

