/* This file has been automatically generated by builder part of the ferite distribution */
/* file:  file_Fifo.c */
/* class: Fifo */

#include <ferite.h>       /* we need this without a doubt */
#include "file_header.h"  /* this is the module header */

FE_NS_FUNCTION( file_Fifo_Fifo )
{
   FeriteObject *super;
   FeriteObject *self;

   ferite_get_parameters( params, 2, &super, &self );

   { /* Main function body. */
 
	   FeriteVariable **params = __ferite_create_parameter_list_from_data( script, "oo", self, self );
	   __ferite_object_call_super( script, self, params );
	   __ferite_delete_parameter_list( script, params );
	
   }
   FE_RETURN_VOID;
}

FE_NS_FUNCTION( file_Fifo_open )
{
   char *filename = fcalloc( strlen(VAS(params[0]))+1, sizeof(char) );
   double writer;
   char *mask = fcalloc( strlen(VAS(params[2]))+1, sizeof(char) );
   FeriteObject *super;
   FeriteObject *self;

   ferite_get_parameters( params, 5, filename, &writer, mask, &super, &self );

   { /* Main function body. */
  
	   int perms, oldmask;
	   char *modes= ((long)writer ? "w" : "r");
	   
	   FileRecycle( FileObj );
	   
	   /*  Clear a space, make a fifo and open it.  */
	   unlink(filename);
	   oldmask=FileUmasking( mask, &perms );
	   ffree( mask );
	   errno=0;
	   if(	!mkfifo(filename, perms) && /*  mknod(filename, S_IFIFO|perms, 0)  */
			(FileObj->fp= fopen( filename, modes )) )
		 FileObj->err=errno;
	   umask(oldmask);
	   
	   if( FileObj->fp==NULL )
	   {
		  ffree( filename );
		  FE_RETURN_LONG( (long)FileObj->err );
	   }
	   
	   /*  Set up the rest of the object..  */
	   FileObj->pathspec= fstrdup(filename);
	   FileObj->modes=	   fstrdup(modes);
	   ffree( filename );
	   if(!FileObj->pathspec || !FileObj->modes)
	   {
		  FileRecycle( FileObj );
		  FileObj->err=ENOMEM;
		  FE_RETURN_LONG( (long)FileObj->err );
	   }
	   
	   FileObj->fd=	fileno( FileObj->fp );
	   FileObj->err=	0;
	   FileObj->fifo=	1;
	   FE_RETURN_LONG( (long)FileObj->err );
    
   }
   FE_RETURN_VOID;
}

