/* This file has been automatically generated by builder part of the ferite distribution */
/* file:  reflection_Function.c */
/* class: Function */

#include <ferite.h>       /* we need this without a doubt */
#include "reflection_header.h"  /* this is the module header */

FE_NS_FUNCTION( reflection_Function_Function )
{
   FeriteObject *self = VAO(params[ferite_get_parameter_count(params) - 1]);

   ferite_get_parameters( params, 0 );

   { /* Main function body. */
 
      FeriteNamespaceBucket *nsb = NULL;
      char buf[2] = ".";
      char *class, *func;
      int i, cleanup = 0;
      int isclass = 0;
      int cp = ferite_get_parameter_count(params);
      FuncObj = fmalloc(sizeof(FunctionHolder));
      if(cp == 3) {
         FeriteClass *fc;
         func = VAS(params[0]);
         if(__ferite_find_string(func,"()") != -1) {
            func = __ferite_copy_string(func,0,strlen(func)-3);
            cleanup = 1;
         }
         if((i = __ferite_find_string(func,".")) != -1) {
            class = __ferite_copy_string(func,0,i-1);
            func = func+i+1;
            FUD(("looking for '%s' in '%s'...\n",func,class));
            fc = __ferite_find_class(script,script->mainns,class);
            if(fc == NULL) {
               ferite_error(script,"Class '%s' does not exist.\n",class);
            }
            if( fc != NULL && __ferite_class_has_function(script,fc,func) != NULL) {
               FuncObj->function = __ferite_class_get_function(script,fc,func);
               FuncObj->is_object = 0;
               if(!FuncObj->function->is_static) {
                  ffree(FuncObj);
                  if(cleanup) { ffree(func); }
                  ferite_error(script,"Function '%s' in class '%s' is not static.\n",
                        func,class);
               }
            } else {
               ffree(FuncObj);
               ferite_error(script,"Function '%s' does not exist.\n",func);
               if(cleanup) { ffree(func); }
            }
         } else {
            nsb = __ferite_find_namespace(script,script->mainns,func,FENS_FNC);
            if(nsb != NULL) {
               FuncObj->function = nsb->data;
               FuncObj->is_object = 0;
            } else {
               ffree(FuncObj);
               if(cleanup) { ffree(func); }
               ferite_error(script,"Unable to find function '%s'\n",params[0]);
            }
         }
      } else if(cp == 4) {
         /* $1 = the object
            $2 = the function */
         FeriteObject *obj = VAO(params[0]);
         func = VAS(params[1]);
         FuncObj->function = __ferite_hash_get(script,obj->functions,func);
         FuncObj->is_object = 1;
         FuncObj->self = params[0];
         FuncObj->super = params[0];
         if(FuncObj->function == NULL) {
            ffree(FuncObj);
            if(cleanup) { ffree(func); }
            ferite_error(script, "Unable to find function '%s' in object '%s'\n",
                  func,obj->name);
         }
      } else {
         ffree(FuncObj);
         if(cleanup) { ffree(func); }
         ferite_error(script,"Invalid parameters\n");
      }
   
   }
   FE_RETURN_VOID;
}

FE_NS_FUNCTION( reflection_Function_exec )
{
   FeriteObject *self = VAO(params[ferite_get_parameter_count(params) - 1]);

   ferite_get_parameters( params, 0 );

   { /* Main function body. */
 
      FeriteVariable *var, *ss, *se;
      FeriteVariable **np;
      int i = 0;
      int cp = ferite_get_parameter_count(params)-2;
      np = __ferite_create_parameter_list(cp+3);
      for(i = 0; i < cp ; i++) {
         FUD(("number of real params: '%d'\n",cp));
         var = ferite_get_parameter(params,i);
         FUD(("param %d: '%s' type '%s'\n",i,var->name,
               __ferite_variable_id_to_str(script,var->type)));
         if(var->type == F_VAR_STR) {
           FUD(("\tvalue='%s'\n",VAS(var)));
         }
         __ferite_add_to_parameter_list(np,__ferite_duplicate_variable(script,var));
      }
      if(FuncObj->is_object) {
         ss = __ferite_duplicate_variable(script,FuncObj->super);
         MARK_VARIABLE_AS_DISPOSABLE(ss);
         ffree(ss->name); ss->name = fstrdup( "super" );
         np = __ferite_add_to_parameter_list(np,ss);
         
         se = __ferite_duplicate_variable(script,FuncObj->self);
         MARK_VARIABLE_AS_DISPOSABLE(se);
         ffree(se->name); se->name = fstrdup( "self" );
         np = __ferite_add_to_parameter_list(np,se);
      }

      FUD(("arg count: '%d'\n",FuncObj->function->arg_count));
      FUD(("calling '%s'...\n",FuncObj->function->name));
      __ferite_call_function(script,FuncObj->function,np);
      __ferite_delete_parameter_list(script,np);
      FUD(("finished\n"));
   
   }
   FE_RETURN_VOID;
}

FE_NS_FUNCTION( reflection_Function_Destructor )
{
   FeriteObject *super;
   FeriteObject *self;

   ferite_get_parameters( params, 2, &super, &self );

   { /* Main function body. */
 
      ffree(FuncObj);
   
   }
   FE_RETURN_VOID;
}

